function SearchElement(){
    /**
     * Private vars
     */    
    var id = "";//coluna do banco
    var name = "";//String que aparece para o usuário
    var isSelectElement = false;
	var sitePath = "http://www.univates.br/roau/";
	var iconsPath = sitePath+"images/";
    var placeholder = "";
    this.options = new Array();
    this.removeIcon = true;
        
    this.setId = setId;
    function setId(id){
        this.id = id;
    }

    this.getId = getId;
    function getId(){
        return this.id;
    }

    this.setName = setName;
    function setName(name){
        this.name = name;
    }

    this.getName = getName;
    function getName(){
        return this.name;
    }

    this.setComboBox = setComboBox;
    function setComboBox(iscombobox){
        this.isSelectElement = iscombobox;
    }

    this.isComboBox = isComboBox;
    function isComboBox(){
        return this.isSelectElement;
    }

    this.setPlaceholder = setPlaceholder;
    function setPlaceholder(placeholder){
        this.placeholder = placeholder;
    }

    this.getPlaceholder = getPlaceholder;
    function getPlaceholder(){
        return this.placeholder;
    }
    
    this.setRemoveIcon = setRemoveIcon;
    function setRemoveIcon(isdelete){
        this.removeIcon = isdelete;
    }

    this.addOption = addOption;
    function addOption(option){
        if(option instanceof SelectOption){
            this.options.push(option);
        }else{
            console.warn('SearchElement.addOption:: The addOption requires an object type SelectOption as parameter.');
        }
    }
    
    /**
     * Retorna o elemento  que será adicionado no final do formulário de busca
     */
    this.getElement = getElement;
    function getElement(){
        
        var content_elem = document.createElement('div');
        content_elem.className = 'col-xs-12';
        content_elem.id = this.id;

        var elem_label = document.createElement('label');
        elem_label.for = this.id;
        elem_label.innerHTML = this.name;
        
        var elem_br = document.createElement('br');
    
        
        var elem = null;

        if(this.isSelectElement){
            var groupname=null;
            var opt = null;

            var elem = document.createElement('select');
            
            for(var i =0; i < this.options.length; i++){
                
                if(this.options[i].getOptgroup() != groupname && this.options[i].getOptgroup() != null){
                    opt = document.createElement('optgroup');
                    opt.label=this.options[i].getOptgroup();
                    groupname = this.options[i].getOptgroup();
                    opt.appendChild(this.options[i].getElement());
                    elem.appendChild(opt);

                }else{
                    if(opt != null){
                        opt.appendChild(this.options[i].getElement());
                    }else{
                        elem.appendChild(this.options[i].getElement());    
                    }
                    
                }

            }
            elem.name = "_select_"+this.id;
        }else{
            elem = document.createElement('input');
            elem.type = 'text';
            elem.placeholder = this.placeholder;                 
            elem.name = this.id;
        }
        elem.id = this.id;
        elem.className = 'col-lx-11';
        
        content_elem.appendChild(elem_label);
        content_elem.appendChild(elem_br);
        content_elem.appendChild(elem);

        var aux = this;

        if(this.removeIcon){
            var ahref = document.createElement('a');
            ahref.setAttribute('href',"javascript:");
	    //ahref.setAttribute("class", "col-lx-1");
            ahref.addEventListener('click',function(e){
                document.querySelector('div#'+aux.id).remove();
            },false);

            var remove = document.createElement('span');
            remove.className = "remove-icon";

            var img_remove = document.createElement('img');
            img_remove.src = iconsPath+"delete.png";
            remove.appendChild(img_remove);
            ahref.appendChild(remove);
            content_elem.appendChild(ahref);
        }
        return content_elem;
    }
}
