
tinymce.init({
	selector:'.tinymce-textarea',
	height: 250,
	language: 'pt_BR',
	    menu: { 
        edit: {title: 'Edit', items: 'undo redo | cut copy paste | selectall'}, 
        format: {title: 'Format', items: 'bold italic underline strikethrough superscript subscript | formats | removeformat'}
    }

});

function selectMultipleFiles(){
	document.getElementById('uploadfiles').click();



}
if(document.getElementById('uploadfiles')){
	document.getElementById('uploadfiles').onchange = function(){
		var list = document.getElementById('filelist');
		while (list.hasChildNodes()) {
	    	list.removeChild(list.lastChild);
		}

		var filelist = document.getElementById("uploadfiles").files || [];
		for (var i = 0; i < filelist.length; i++) {
			var file_li = document.createElement('li');
			file_li.innerHTML = filelist[i].name;
		    document.getElementById('filelist').appendChild(file_li);
		}
	};
}

/**
 * Implementação da função remove().
 * ex. document.getElementById("my-element").remove();
 */
Element.prototype.remove = function() {
    this.parentElement.removeChild(this);
}
NodeList.prototype.remove = HTMLCollection.prototype.remove = function() {
    for(var i = 0, len = this.length; i < len; i++) {
        if(this[i] && this[i].parentElement) {
            this[i].parentElement.removeChild(this[i]);
        }
    }
}

function view_fileTree(filePath){
	$(document).ready( function() {
		$('#filelist').fileTree({
			root: filePath,
			script: 'filetree.jsp',
			expandSpeed: 500,
			collapseSpeed: 500,
			multiFolder: false
		});
	});
}